﻿<%@ Control Language="C#" Inherits="System.Web.Mvc.ViewUserControl" %>

<div id="searchResultsStatic" class="panel searchResults">
    <% var model = ViewData["PagingResult"] as PagingResult<Activity>; %>
    <% var searchCriteria = ViewData["SearchCriteria"] as ActivitySearchCriteria; %>
    <div class="innerPanel">
        <h2>
            <ul>
                <li><strong>Activities</strong></li>
            </ul>
        </h2>

        <div>
            
            <% if(searchCriteria != null) { %>
            <div class="subheader">
                Sort by:
                <% if(searchCriteria.SortBy == SortCriteria.Name) { %>
                    <strong>Name</strong>
                <% } else { %>
                    <%=Html.ActionLink("Name", "Search", new ActivitySearchCriteria { SortBy = SortCriteria.Name, State = searchCriteria.State, City = searchCriteria.City, StreetAddress = searchCriteria.StreetAddress, Zip = searchCriteria.Zip, ActivityTypeId = searchCriteria.ActivityTypeId })%>
                <% } %>
                |
                <% if(searchCriteria.SortBy == SortCriteria.Rating) { %>
                    <strong>Rating</strong>
                <% } else { %>
                    <%=Html.ActionLink("Rating", "Search", new ActivitySearchCriteria { SortBy = SortCriteria.Rating, State = searchCriteria.State, City = searchCriteria.City, StreetAddress = searchCriteria.StreetAddress, Zip = searchCriteria.Zip, ActivityTypeId = searchCriteria.ActivityTypeId })%>
                <% } %>
                |
                <% if(searchCriteria.SortBy == SortCriteria.ActivityType) { %>
                    <strong>Type</strong>
                <% } else { %>
                    <%=Html.ActionLink("Type", "Search", new ActivitySearchCriteria { SortBy = SortCriteria.ActivityType, State = searchCriteria.State, City = searchCriteria.City, StreetAddress = searchCriteria.StreetAddress, Zip = searchCriteria.Zip, ActivityTypeId = searchCriteria.ActivityTypeId })%>
                <% } %>
            </div>
            <% } %>

            <div class="items">
                <% if(model == null) %>
                <% { %>
                    <h3>Please provide a search criteria...</h3>
                <% } else { %>
                    <% if(model.TotalItems == 0) %>
                    <% { %>
                        <h3>No activities found...</h3>
                    <% } else {%>
                        <ul class="activities">
                            <% foreach(var activity in model.Items) %>
                            <% { %>
                            <li>
                               <%
                                   var rating = activity.Rating ?? 0;
                                   rating = Math.Round(rating * 2) / 2;
                                %>
                                <span class="off id"><%=Html.Encode(activity.Id)%></span>
                                <h3>
                                <% if (rating > 0)
                                   { %>
                                    <span class="rating rating_<%=rating.ToString("0.0").Replace(".", "_")%>"><span>Rating: </span><%=rating.ToString("0.0")%></span>
                                <%} %>
                                    <%=Html.ActionLink(activity.Name, "Details", "Activities", new { id = activity.Id }, null)%>
                                </h3>
                                <p><%=Html.Encode(activity.Street)%> | <%=Html.Encode(activity.City)%>, <%=Html.Encode(activity.State)%> <%=Html.Encode(activity.Zip)%> | Phone: <%=Html.Encode(activity.PhoneNumber)%></p>
                            </li>
                            <% } %>
                        </ul>
                    <% } %>
                <% } %>
            </div>

       <div class="toolbox">
            <% if (model != null && model.TotalPages > 0) %>
            <% { %>
                <div class="pager">
                    <% if(model.CurrentPage == 1) %>
                    <% { %>
                        <strong>«</strong>
                    <% } else { %>
                        <%=Html.ActionLink("«", "Search", new ActivitySearchCriteria { Page = model.CurrentPage - 1, SortBy = searchCriteria.SortBy, State = searchCriteria.State, City = searchCriteria.City, StreetAddress = searchCriteria.StreetAddress, Zip = searchCriteria.Zip, ActivityTypeId = searchCriteria.ActivityTypeId })%>
                    <% } %>
                    |                
                    <% for(int i=1; i<=model.TotalPages; i++) %>
                    <% { %>
                        <% if(i == model.CurrentPage) { %>
                            <strong><%=i%></strong>
                        <% } else { %>
                            <%=Html.ActionLink(i.ToString(), "Search", new ActivitySearchCriteria { Page = i, SortBy = searchCriteria.SortBy, State = searchCriteria.State, City = searchCriteria.City, StreetAddress = searchCriteria.StreetAddress, Zip = searchCriteria.Zip, ActivityTypeId = searchCriteria.ActivityTypeId })%>
                        <% } %>
                        |
                    <% } %>
                    
                    <% if(model.CurrentPage == model.TotalPages) %>
                    <% { %>
                        <strong>»</strong>
                    <% } else { %>
                        <%=Html.ActionLink("»", "Search", new ActivitySearchCriteria { Page = model.CurrentPage + 1, SortBy = searchCriteria.SortBy, State = searchCriteria.State, City = searchCriteria.City, StreetAddress = searchCriteria.StreetAddress, Zip = searchCriteria.Zip, ActivityTypeId = searchCriteria.ActivityTypeId })%>
                    <% } %>
                </div>
            <% } %>
        </div>

        </div>
    </div>
</div>
