﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ContentPlaceHolderID="TitleContent" runat="server">Plan My Night - <%=Html.Encode(((Activity)ViewData["Activity"]).Name) %></asp:Content>

<asp:Content ContentPlaceHolderID="MainContent" runat="server">
    <%
        var activity = ViewData["Activity"] as Activity;
        var rating = activity.Rating ?? 0;
        rating = Math.Round(rating * 2) / 2;
    %>
    <div class="panel">
        <div class="innerPanel">
            <h2><span><%=Html.Encode(activity.Name) %></span></h2>
        </div>
        <div class="items">
            <p>Rating: 
            <% if(rating > 0) { %>
                <span class="rating rating_<%=rating.ToString("0.0").Replace(".", "_")%>"><%=rating.ToString("0.0")%></span>
            <% } else { %>
                Awaiting at least one more vote.
            <% } %>
            </p>
            <p><%=Html.Encode(activity.Street)%> | <%=Html.Encode(activity.City)%>, <%=Html.Encode(activity.State)%> <%=Html.Encode(activity.Zip)%> | Phone: <%=Html.Encode(activity.PhoneNumber)%></p>
        </div>
        <div class="toolbox">
                <% using (Html.BeginForm("Rate","Activities",new { Id=activity.Id}, FormMethod.Post,null)) %>
                <% { %>
                    | Rating:
                    <%=Html.DropDownList("Rating", new[] { new SelectListItem { Text = "1" }, new SelectListItem { Text = "2" }, new SelectListItem { Text = "3" }, new SelectListItem { Text = "4" }, new SelectListItem { Text = "5" } })%>
                    <input type="submit" value="Rate »" />
                <% } %>
        </div>
    </div>
</asp:Content>