// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

namespace PlanMyNight.Controllers
{
    using System.Globalization;
    using System.Web.Mvc;
    using PlanMyNight.Models;

    [OutputCache(NoStore = true, Duration = 0, VaryByParam = "*")]
    public class ActivitiesController : Controller
    {
        private readonly IActivitiesRepository repository;

        public ActivitiesController() :
            this(new ActivitiesRepository())
        {
        }

        public ActivitiesController(IActivitiesRepository repository)
        {
            this.repository = repository;
        }

        public ActionResult Details(string id)
        {
            var activity = this.repository.Retrieve(id);
            if (activity == null)
            {
                return Redirect("~/");
            }

            this.ViewData["Activity"] = activity;

            return View();
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Rate(string id)
        {
            var rating = byte.Parse(Request.Form["Rating"], CultureInfo.InvariantCulture);
            this.repository.RateActivity(id, rating);

            return RedirectToAction("Details", new { id = id });
        }
    }
}