// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

namespace PlanMyNight.Models.Entities
{
    using System.ComponentModel.DataAnnotations;

    [CustomValidation(typeof(ActivitySearchCriteria), "IsValid")]
    public class ActivitySearchCriteria
    {
        public int? ActivityTypeId { get; set; }

        public string StreetAddress { get; set; }

        public string City { get; set; }

        public string State { get; set; }

        public string Zip { get; set; }

        public SortCriteria SortBy { get; set; }

        public int Page { get; set; }

        public int PageSize { get; set; }

        public static ValidationResult IsValid(ActivitySearchCriteria criteria)
        {
            if (!string.IsNullOrEmpty(criteria.City) ||
                !string.IsNullOrEmpty(criteria.State) ||
                !string.IsNullOrEmpty(criteria.Zip) ||
                !string.IsNullOrEmpty(criteria.StreetAddress))
            {
                return ValidationResult.Success;
            }
            else
            {
                return new ValidationResult("Please provide a search criteria.");
            }
        }
    }
}